Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/limit_netcdf.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/limit_netcdf.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/limit_netcdf.F90	(revision 2641)
@@ -67,7 +67,8 @@
                   NF90_DEF_DIM, NF90_DEF_VAR, NF90_PUT_VAR, NF90_PUT_ATT,      &
                   NF90_NOERR,   NF90_NOWRITE, NF90_DOUBLE,  NF90_GLOBAL,       &
-		  NF90_CLOBBER, NF90_ENDDEF,  NF90_UNLIMITED, NF90_FLOAT
+                  NF90_CLOBBER, NF90_ENDDEF,  NF90_UNLIMITED, NF90_FLOAT
   USE inter_barxy_m,      ONLY: inter_barxy
   USE netcdf95,           ONLY: nf95_def_var, nf95_put_att, nf95_put_var
+  USE comconst_mod, ONLY: pi
   IMPLICIT NONE
 !-------------------------------------------------------------------------------
@@ -81,7 +82,5 @@
 !-------------------------------------------------------------------------------
 ! Local variables:
-  include "logic.h"
   include "comgeom2.h"
-  include "comconst.h"
 
 !--- INPUT NETCDF FILES NAMES --------------------------------------------------
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/test_disvert_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/test_disvert_m.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/test_disvert_m.F90	(revision 2641)
@@ -15,10 +15,8 @@
     use exner_hyb_m, only: exner_hyb
     use vertical_layers_mod, only: ap,bp,preff
+    use comconst_mod, only: kappa, cpp
 
     ! For llm:
     include "dimensions.h"
-
-    ! For kappa, cpp:
-    include "comconst.h"
 
     ! Local:
Index: LMDZ5/branches/testing/libf/dynphy_lonlat/phymar/iniphysiq_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dynphy_lonlat/phymar/iniphysiq_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/dynphy_lonlat/phymar/iniphysiq_mod.F90	(revision 2641)
@@ -12,5 +12,7 @@
                      prad,pg,pr,pcpp,iflag_phys)
   USE dimphy, ONLY: init_dimphy
+  USE comvert_mod, ONLY: preff, ap, bp, presnivs, scaleheight, pseudoalt
   USE inigeomphy_mod, ONLY: inigeomphy
+  USE vertical_layers_mod, ONLY : init_vertical_layers
   USE infotrac, ONLY: nqtot
   USE comcstphy, ONLY: rradius, & ! planet radius (m)
@@ -69,4 +71,8 @@
 !$OMP PARALLEL
 
+  ! copy over preff , ap(), bp(), etc 
+  CALL init_vertical_layers(nlayer,preff,scaleheight, &
+                            ap,bp,presnivs,pseudoalt)
+
   ! Initialize tracer names, numbers, etc. for physics
   CALL init_infotrac_phy(nqtot)
Index: LMDZ5/branches/testing/libf/filtrez/filtreg_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/filtrez/filtreg_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/filtrez/filtreg_mod.F90	(revision 2641)
@@ -14,4 +14,6 @@
   USE mod_filtre_fft_loc, ONLY : Init_filtre_fft_loc=>Init_filtre_fft    !
 #endif
+  USE serre_mod, ONLY: alphax
+  USE logic_mod, ONLY: fxyhypb, ysinus
     !    ... H. Upadhyaya, O.Sharma   ...
     !
@@ -22,11 +24,9 @@
     !     Correction  le 28/10/97    P. Le Van .
     !  -------------------------------------------------------------------
-#include "dimensions.h"
-#include "paramet.h"
+    include "dimensions.h"
+    include "paramet.h"
     !  -------------------------------------------------------------------
-#include "comgeom.h"
-#include "coefils.h"
-#include "logic.h"
-#include "serre.h"
+    include "comgeom.h"
+    include "coefils.h"
 
     REAL  dlonu(iim),dlatu(jjm)
Index: LMDZ5/branches/testing/libf/filtrez/inifgn.F
===================================================================
--- LMDZ5/branches/testing/libf/filtrez/inifgn.F	(revision 2595)
+++ LMDZ5/branches/testing/libf/filtrez/inifgn.F	(revision 2641)
@@ -8,8 +8,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
-#include "serre.h"
+      include "dimensions.h"
+      include "paramet.h"
+      include "comgeom.h"
 
 c
@@ -20,5 +19,5 @@
       INTEGER i,j,k,imm1,nrot
 C
-#include "coefils.h"
+      include "coefils.h"
 c
       EXTERNAL SSUM, acc,eigen,jacobi
Index: LMDZ5/branches/testing/libf/phy_common/iophys.F90
===================================================================
--- LMDZ5/branches/testing/libf/phy_common/iophys.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phy_common/iophys.F90	(revision 2641)
@@ -0,0 +1,132 @@
+      subroutine iophys_ecrit(nom,lllm,titre,unite,px)
+      USE dimphy
+      USE mod_phys_lmdz_para
+      USE mod_grid_phy_lmdz
+      IMPLICIT NONE
+
+
+
+!  Ecriture de variables diagnostiques au choix dans la physique 
+!  dans un fichier NetCDF nomme  'diagfi'. Ces variables peuvent etre
+!  3d (ex : temperature), 2d (ex : temperature de surface), ou
+!  0d (pour un scalaire qui ne depend que du temps : ex : la longitude
+!  solaire)
+!  (ou encore 1d, dans le cas de testphys1d, pour sortir une colonne)
+!  La periode d'ecriture est donnee par 
+!  "ecritphy " regle dans le fichier de controle de run :  run.def
+!
+!    writediagfi peut etre appele de n'importe quelle subroutine
+!    de la physique, plusieurs fois. L'initialisation et la creation du
+!    fichier se fait au tout premier appel.
+!
+! WARNING : les variables dynamique (u,v,t,q,ps)
+!  sauvees par writediagfi avec une
+! date donnee sont legerement differentes que dans le fichier histoire car 
+! on ne leur a pas encore ajoute de la dissipation et de la physique !!!
+! IL est  RECOMMANDE d'ajouter les tendance physique a ces variables
+! avant l'ecriture dans diagfi (cf. physiq.F)
+!  
+! Modifs: Aug.2010 Ehouarn: enforce outputs to be real*4
+!
+!  parametres (input) :
+!  ----------
+!      unit : unite logique du fichier de sortie (toujours la meme)
+!      nom  : nom de la variable a sortir (chaine de caracteres)
+!      titre: titre de la variable (chaine de caracteres)
+!      unite : unite de la variable (chaine de caracteres)
+!      px : variable a sortir (real 0, 1, 2, ou 3d)
+!
+!=================================================================
+
+#include "dimensions.h"
+#include "paramet.h"
+#include "netcdf.inc"
+#include "iotd.h"
+
+
+! Arguments on input:
+      integer lllm
+      character (len=*) :: nom,titre,unite
+      integer imjmax
+      parameter (imjmax=100000)
+      real px(klon_omp,lllm)
+      real xglo(klon_glo,lllm)
+      real zx(iim,jjp1,lllm)
+
+
+      CALL Gather(px,xglo)
+!$OMP MASTER
+      IF (is_mpi_root) THEN       
+        CALL Grid1Dto2D_glo(xglo,zx)
+        call iotd_ecrit(nom,lllm,titre,unite,zx)
+      ENDIF
+!$OMP END MASTER
+
+      return
+      end
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+      SUBROUTINE iophys_ini
+      USE mod_phys_lmdz_para
+      USE vertical_layers_mod, ONLY: presnivs
+      USE regular_lonlat_mod, ONLY: lon_reg, lat_reg
+      USE dimphy, ONLY: klev
+
+      IMPLICIT NONE
+
+!=======================================================================
+!
+!   Auteur:  L. Fairhead  ,  P. Le Van, Y. Wanherdrick, F. Forget
+!   -------
+!
+!   Objet:
+!   ------
+!
+!   'Initialize' the diagfi.nc file: write down dimensions as well
+!   as time-independent fields (e.g: geopotential, mesh area, ...)
+!
+!=======================================================================
+!-----------------------------------------------------------------------
+!   Declarations:
+!   -------------
+
+real pi
+
+!   Arguments:
+!   ----------
+
+!$OMP MASTER
+    IF (is_mpi_root) THEN       
+pi=2.*asin(1.)
+call iotd_ini('phys.nc   ', &
+!iim,jjp1,llm,rlonv(1:iim)*180./pi,rlatu*180./pi,presnivs)
+size(lon_reg),size(lat_reg),klev,lon_reg(:)*180./pi,lat_reg*180./pi,presnivs)
+    ENDIF
+!$OMP END MASTER
+
+      END
+
+#ifdef und
+      SUBROUTINE gr_fi_ecrit(nfield,nlon,iim,jjmp1,fi,ecrit)
+      IMPLICIT none
+
+!=======================================================================
+      INTEGER nfield,nlon,iim,jjmp1, jjm
+      REAL fi(nlon,nfield), ecrit(iim*jjmp1,nfield)
+
+      INTEGER i, n, ig
+
+      jjm = jjmp1 - 1
+      DO n = 1, nfield
+         DO i=1,iim
+            ecrit(i,n) = fi(1,n)
+            ecrit(i+jjm*iim,n) = fi(nlon,n)
+         ENDDO
+         DO ig = 1, nlon - 2
+           ecrit(iim+ig,n) = fi(1+ig,n)
+         ENDDO
+      ENDDO
+      RETURN
+      END
+
+#endif
Index: LMDZ5/branches/testing/libf/phylmd/Dust/aeropt_spl.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/aeropt_spl.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/aeropt_spl.F	(revision 2641)
@@ -0,0 +1,251 @@
+      SUBROUTINE aeropt_spl(zdz, tr_seri, RHcl,
+     .              id_prec, id_fine, id_coss, id_codu, id_scdu,
+     .              ok_chimeredust,
+     .                      ztaue550,ztaue670,ztaue865,
+     .                      taue550_tr2,taue670_tr2,taue865_tr2,
+     .                      taue550_ss,taue670_ss,taue865_ss,
+     .                      taue550_dust,taue670_dust,taue865_dust,
+     .             taue550_dustsco,taue670_dustsco,taue865_dustsco)
+c
+      USE dimphy
+      USE infotrac
+      IMPLICIT none
+c
+#include "chem.h"
+#include "dimensions.h"
+c #include "dimphy.h"
+#include "YOMCST.h"
+c
+c Arguments:
+c
+c======================== INPUT ==================================      
+      REAL zdz(klon,klev)
+      REAL tr_seri(klon,klev,nbtr) ! masse of tracer 
+      REAL RHcl(klon,klev)     ! humidite relativen ciel clair
+      INTEGER  id_prec, id_fine, id_coss, id_codu, id_scdu
+      LOGICAL ok_chimeredust
+c============================== OUTPUT =================================
+      REAL ztaue550(klon) ! epaisseur optique aerosol 550 nm
+      REAL ztaue670(klon) ! epaisseur optique aerosol 670 nm
+      REAL ztaue865(klon) ! epaisseur optique aerosol 865 nm
+      REAL taue550_tr2(klon) ! epaisseur optique aerosol 550 nm, diagnostic
+      REAL taue670_tr2(klon) ! epaisseur optique aerosol 670 nm, diagnostic
+      REAL taue865_tr2(klon) ! epaisseur optique aerosol 865 nm, diagnostic
+      REAL taue550_ss(klon) ! epaisseur optique aerosol 550 nm, diagnostic
+      REAL taue670_ss(klon) ! epaisseur optique aerosol 670 nm, diagnostic
+      REAL taue865_ss(klon) ! epaisseur optique aerosol 865 nm, diagnostic
+      REAL taue550_dust(klon) ! epaisseur optique aerosol 550 nm, diagnostic
+      REAL taue670_dust(klon) ! epaisseur optique aerosol 670 nm, diagnostic
+      REAL taue865_dust(klon) ! epaisseur optique aerosol 865 nm, diagnostic
+      REAL taue550_dustsco(klon) ! epaisseur optique aerosol 550 nm, diagnostic
+      REAL taue670_dustsco(klon) ! epaisseur optique aerosol 670 nm, diagnostic
+      REAL taue865_dustsco(klon) ! epaisseur optique aerosol 865 nm, diagnostic
+c===================== LOCAL VARIABLES ===========================      
+      INTEGER nb_lambda,nbre_RH
+      PARAMETER (nb_lambda=3,nbre_RH=12)
+      INTEGER i, k, RH_num
+      REAL rh, RH_MAX, DELTA, RH_tab(nbre_RH)
+      PARAMETER (RH_MAX=95.)
+      INTEGER rh_int
+      PARAMETER (rh_int=12)
+      REAL auxreal
+c      REAL ss_a(nb_lambda,int,nbtr-1)
+c      DATA ss_a/72*1./
+      REAL ss_dust(nb_lambda), ss_acc550(rh_int), alpha_acc
+      REAL ss_dustsco(nb_lambda)
+      REAL ss_acc670(rh_int), ss_acc865(rh_int)
+      REAL ss_ssalt550(rh_int)
+      REAL ss_ssalt670(rh_int), ss_ssalt865(rh_int)
+      REAL burden_ss(klon)
+      DATA ss_acc550 /3.135,3.135,3.135, 3.135, 4.260, 4.807,
+     .                5.546,6.651,8.641,10.335,13.534,22.979/
+      DATA ss_acc670 /2.220,2.220,2.220, 2.220, 3.048, 3.460,
+     .                4.023,4.873,6.426, 7.761,10.322,18.079/
+      DATA ss_acc865 /1.329,1.329,1.329, 1.329, 1.855, 2.124,
+     .                2.494,3.060,4.114, 5.033, 6.831,12.457/  
+!old4tracers      DATA ss_dust/0.564, 0.614, 0.700/ !for bin 0.5-10um
+!      DATA ss_dust/0.553117, 0.610185, 0.7053460 / !for bin 0.5-3um radius
+!      DATA ss_dustsco/0.1014, 0.102156, 0.1035538 / !for bin 3-15um radius
+!20140902      DATA ss_dust/0.5345737, 0.5878828, 0.6772957/ !for bin 0.5-3um radius
+!20140902      DATA ss_dustsco/0.1009634, 0.1018700, 0.1031178/ !for bin 3-15um radius
+!3days      DATA ss_dust/0.4564216, 0.4906738, 0.5476248/ !for bin 0.5-3um radius
+!3days      DATA ss_dustsco/0.1015022, 0.1024051, 0.1036622/ !for bin 3-15um radius
+!JE20140911      DATA ss_dust/0.5167768,0.5684330,0.6531643/ !for bin 0.5-3um radius
+!JE20140911      DATA ss_dustsco/0.1003391,0.1012288,0.1024651/ !for bin 3-15um radius
+!JE20140915      DATA ss_dust/0.3188754,0.3430106,0.3829019/ !for bin 0.5-5um radius
+!JE20140915      DATA ss_dustsco/8.0582686E-02,8.1255026E-02,8.1861295E-02/ !for bin 5-15um radius
+
+!      DATA ss_dust/0.5167768,0.5684330,0.6531643/ !for bin 0.5-3um radius
+!      DATA ss_dustsco/0.1003391,0.1012288,0.1024651/ !for bin 3-15um radius
+
+
+      DATA ss_ssalt550/0.182,0.182,0.182,0.182,0.366,0.430,
+     .                 0.484,0.551,0.648,0.724,0.847,1.218/ !for bin 0.5-20 um, fit_v2
+      DATA ss_ssalt670/0.193,0.193,0.193,0.193,0.377,0.431,
+     .                 0.496,0.587,0.693,0.784,0.925,1.257/ !for bin 0.5-20 um
+      DATA ss_ssalt865/0.188,0.188,0.188,0.188,0.384,0.443,
+     .                 0.502,0.580,0.699,0.799,0.979,1.404/ !for bin 0.5-20 um
+
+      DATA RH_tab/0.,10.,20.,30.,40.,50.,60.,70.,80.,85.,90.,95./
+c
+      IF (ok_chimeredust) THEN 
+!JE20150212<< : changes in ustar in dustmod changes emission distribution
+!      ss_dust=(/0.5167768,0.5684330,0.6531643/)
+!      ss_dustsco=(/0.1003391,0.1012288,0.1024651/)
+! JE20150618: Change in dustmodule, div3 is now =6: change distributions
+! div3=3      ss_dust   =(/0.4670522 , 0.5077308 , 0.5745184/)
+! div3=3      ss_dustsco=(/0.099858  , 0.1007395 , 0.1019673/)
+      ss_dust   =(/0.4851232 , 0.5292494 , 0.5935509/)
+      ss_dustsco=(/0.1001981 , 0.1011043 , 0.1023113/)
+
+!JE20150212>>
+
+      ELSE
+      ss_dust=(/0.564, 0.614, 0.700/)
+      ss_dustsco=(/0.,0.,0./)
+      ENDIF
+
+      DO i=1, klon
+        ztaue550(i)=0.0
+        ztaue670(i)=0.0
+        ztaue865(i)=0.0
+        taue550_tr2(i)=0.0
+        taue670_tr2(i)=0.0
+        taue865_tr2(i)=0.0
+        taue550_ss(i)=0.0
+        taue670_ss(i)=0.0
+        taue865_ss(i)=0.0
+        taue550_dust(i)=0.0
+        taue670_dust(i)=0.0
+        taue865_dust(i)=0.0
+        taue550_dustsco(i)=0.0
+        taue670_dustsco(i)=0.0
+        taue865_dustsco(i)=0.0
+        burden_ss(i)=0.0
+      ENDDO
+
+      DO k=1, klev
+      DO i=1, klon
+c     
+      rh=MIN(RHcl(i,k)*100.,RH_MAX)
+      RH_num = INT( rh/10. + 1.)
+      IF (rh.gt.85.) RH_num=10
+      IF (rh.gt.90.) RH_num=11
+c      IF (rh.gt.40.) THEN 
+c          RH_num=5   ! Added by NHL temporarily
+c          print *,'TEMPORARY CASE'
+c      ENDIF
+      DELTA=(rh-RH_tab(RH_num))/(RH_tab(RH_num+1)-RH_tab(RH_num))
+
+
+c*******************************************************************
+c                       AOD at 550 NM
+c*******************************************************************
+        alpha_acc=ss_acc550(RH_num) + DELTA*(ss_acc550(RH_num+1)-
+     .            ss_acc550(RH_num))              !--m2/g
+cnhl_test TOTAL AOD
+       auxreal=0.
+      IF(id_fine>0) auxreal=auxreal+alpha_acc*tr_seri(i,k,id_fine)
+      IF(id_coss>0) auxreal=auxreal+ss_ssalt550(RH_num)*
+     .                       tr_seri(i,k,id_coss)
+      IF(id_codu>0) auxreal=auxreal+ss_dust(1)*tr_seri(i,k,id_codu)
+      IF(id_scdu>0) auxreal=auxreal+ss_dustsco(1)*tr_seri(i,k,id_scdu)
+      ztaue550(i)=ztaue550(i)+auxreal*zdz(i,k)*1.e6
+    
+!JE20150128        ztaue550(i)=ztaue550(i)+(alpha_acc*tr_seri(i,k,id_fine)+
+!     .                 ss_ssalt550(RH_num)*tr_seri(i,k,id_coss)+
+!     .                 ss_dust(1)*tr_seri(i,k,id_codu)+
+!     .              ss_dustsco(1)*tr_seri(i,k,id_scdu)  )*zdz(i,k)*1.e6
+
+cnhl_test TOTAL AOD IS NOW AOD COARSE MODE ONLY
+cnhl_test        ztaue550(i)=ztaue550(i)+(                     
+cnhl_test     .                 ss_ssalt550(RH_num)*tr_seri(i,k,3)+
+cnhl_test     .                 ss_dust(1)*tr_seri(i,k,4))*zdz(i,k)*1.e6
+
+        IF(id_fine>0) taue550_tr2(i)=taue550_tr2(i)
+     .               + alpha_acc*tr_seri(i,k,id_fine)*zdz(i,k)*1.e6
+        IF(id_coss>0) taue550_ss(i)=taue550_ss(i)+
+     .                ss_ssalt550(RH_num)*tr_seri(i,k,id_coss)*
+     .                zdz(i,k)*1.e6
+        IF(id_codu>0) taue550_dust(i)=taue550_dust(i)+
+     .                ss_dust(1)*tr_seri(i,k,id_codu)*
+     .                zdz(i,k)*1.e6
+        IF(id_scdu>0) taue550_dustsco(i)=taue550_dustsco(i)+
+     .                ss_dustsco(1)*tr_seri(i,k,id_scdu)*
+     .                zdz(i,k)*1.e6
+!        print *,'taue550_ss = ',SUM(taue550_ss),MINVAL(taue550_ss),
+!     .                                          MAXVAL(taue550_ss)
+
+c*******************************************************************
+c                       AOD at 670 NM
+c*******************************************************************
+        alpha_acc=ss_acc670(RH_num) + DELTA*(ss_acc670(RH_num+1)-
+     .            ss_acc670(RH_num))              !--m2/g
+      auxreal=0.
+      IF(id_fine>0) auxreal=auxreal+alpha_acc*tr_seri(i,k,id_fine)
+      IF(id_coss>0) auxreal=auxreal+ss_ssalt670(RH_num)
+     .                      *tr_seri(i,k,id_coss)
+      IF(id_codu>0) auxreal=auxreal+ss_dust(2)*tr_seri(i,k,id_codu)
+      IF(id_scdu>0) auxreal=auxreal+ss_dustsco(2)*tr_seri(i,k,id_scdu)
+      ztaue670(i)=ztaue670(i)+auxreal*zdz(i,k)*1.e6
+
+!JE20150128        ztaue670(i)=ztaue670(i)+(alpha_acc*tr_seri(i,k,id_fine)+
+!     .                 ss_ssalt670(RH_num)*tr_seri(i,k,id_coss)+
+!     .                 ss_dust(2)*tr_seri(i,k,id_codu)+
+!     .               ss_dustsco(2)*tr_seri(i,k,id_scdu))*zdz(i,k)*1.e6
+
+      IF(id_fine>0)  taue670_tr2(i)=taue670_tr2(i)+
+     .                alpha_acc*tr_seri(i,k,id_fine)*
+     .                 zdz(i,k)*1.e6
+      IF(id_coss>0)  taue670_ss(i)=taue670_ss(i)+
+     .                ss_ssalt670(RH_num)*tr_seri(i,k,id_coss)*
+     .                zdz(i,k)*1.e6
+      IF(id_codu>0)  taue670_dust(i)=taue670_dust(i)
+     .                +ss_dust(2)*tr_seri(i,k,id_codu)*
+     .                zdz(i,k)*1.e6
+      IF(id_scdu>0)  taue670_dustsco(i)=taue670_dustsco(i)+
+     .                ss_dustsco(2)*tr_seri(i,k,id_scdu)*
+     .                zdz(i,k)*1.e6
+
+c*******************************************************************
+c                       AOD at 865 NM
+c*******************************************************************
+        alpha_acc=ss_acc865(RH_num) + DELTA*(ss_acc865(RH_num+1)-
+     .            ss_acc865(RH_num))              !--m2/g
+        auxreal=0.
+      IF(id_fine>0) auxreal=auxreal+alpha_acc*tr_seri(i,k,id_fine)
+      IF(id_coss>0) auxreal=auxreal
+     .                     +ss_ssalt865(RH_num)*tr_seri(i,k,id_coss)
+      IF(id_codu>0) auxreal=auxreal+ss_dust(3)*tr_seri(i,k,id_codu)
+      IF(id_scdu>0) auxreal=auxreal+ss_dustsco(3)*tr_seri(i,k,id_scdu)
+        ztaue865(i)=ztaue865(i)+auxreal*zdz(i,k)*1.e6
+!JE20150128        ztaue865(i)=ztaue865(i)+(alpha_acc*tr_seri(i,k,id_fine)+
+!     .                 ss_ssalt865(RH_num)*tr_seri(i,k,id_coss)+
+!     .                 ss_dust(3)*tr_seri(i,k,id_codu)+
+!     .               ss_dustsco(3)*tr_seri(i,k,id_scdu))*zdz(i,k)*1.e6
+      IF(id_fine>0) taue865_tr2(i)=taue865_tr2(i)
+     .                +alpha_acc*tr_seri(i,k,id_fine)*
+     .                 zdz(i,k)*1.e6
+      IF(id_coss>0) taue865_ss(i)=taue865_ss(i)+
+     .                ss_ssalt865(RH_num)*tr_seri(i,k,id_coss)*
+     .                zdz(i,k)*1.e6
+      IF(id_codu>0)  taue865_dust(i)=taue865_dust(i)
+     .                +ss_dust(3)*tr_seri(i,k,id_codu)*
+     .                zdz(i,k)*1.e6
+      IF(id_scdu>0)  taue865_dustsco(i)=taue865_dustsco(i)+
+     .                ss_dustsco(3)*tr_seri(i,k,id_scdu)*
+     .                zdz(i,k)*1.e6
+
+
+c
+      IF(id_coss>0)  burden_ss(i)=burden_ss(i)
+     .                +tr_seri(i,k,id_coss)*1.e6*1.e3*zdz(i,k)
+      ENDDO            !-loop on klev
+      ENDDO            !-loop on klon
+!      print *,'tr_seri = ',SUM(tr_seri(:,:,3)),MINVAL(tr_seri(:,:,3)),
+!     .                                          MAXVAL(tr_seri(:,:,3))
+!      print *,'taue550_ss = ',SUM(taue550_ss),MINVAL(taue550_ss),
+!     .                                        MAXVAL(taue550_ss)
+c
+      RETURN
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/bcscav_spl.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/bcscav_spl.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/bcscav_spl.F	(revision 2641)
@@ -0,0 +1,55 @@
+      SUBROUTINE bcscav_spl(pdtime,flxr,flxs,alpha_r,alpha_s,x,dx) 
+
+      USE dimphy
+      IMPLICIT NONE 
+c=====================================================================
+c Objet : below-cloud scavenging of tracers
+c Date : september 1999
+c Auteur: O. Boucher (LOA) 
+c=====================================================================
+c
+#include "dimensions.h"
+#include "chem.h"
+#include "YOMCST.h"
+#include "YOECUMF.h"
+c
+      REAL pdtime, alpha_r, alpha_s, R_r, R_s 
+      PARAMETER (R_r=0.001)          !--mean raindrop radius (m)
+      PARAMETER (R_s=0.001)          !--mean snow crystal radius (m)
+      REAL flxr(klon,klev)         ! liquid precipitation rate (kg/m2/s)
+      REAL flxs(klon,klev)         ! solid  precipitation rate (kg/m2/s)
+      REAL flxr_aux(klon,klev+1)
+      REAL flxs_aux(klon,klev+1)
+      REAL x(klon,klev)              ! q de traceur  
+      REAL dx(klon,klev)             ! tendance de traceur
+c
+c--variables locales      
+      INTEGER i, k 
+      REAL pr, ps, ice, water
+c
+c------------------------------------------
+c
+! NHL
+! Auxiliary variables defined to deal with the fact that precipitation
+! fluxes are defined on klev levels only.
+! NHL
+!
+      flxr_aux(:,klev+1)=0.0
+      flxs_aux(:,klev+1)=0.0
+      flxr_aux(:,1:klev)=flxr(:,:)
+      flxs_aux(:,1:klev)=flxs(:,:)
+!
+      DO k=1, klev
+      DO i=1, klon 
+       pr=0.5*(flxr_aux(i,k)+flxr_aux(i,k+1))
+       ps=0.5*(flxs_aux(i,k)+flxs_aux(i,k+1))
+       water=pr*alpha_r/R_r/rho_water
+       ice=ps*alpha_s/R_s/rho_ice
+       dx(i,k)=-3./4.*x(i,k)*pdtime*(water+ice)
+ctmp       dx(i,k)=-3./4.*x(i,k)*pdtime* 
+ctmp     .         (pr*alpha_r/R_r/rho_water+ps*alpha_s/R_s/rho_ice)
+      ENDDO 
+      ENDDO
+c
+      RETURN 
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/bl_for_dms.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/bl_for_dms.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/bl_for_dms.F	(revision 2641)
@@ -0,0 +1,105 @@
+      SUBROUTINE bl_for_dms(u,v,paprs,pplay,cdragh,cdragm
+     .                     ,t,q,tsol,ustar,obklen)
+      USE dimphy
+      IMPLICIT NONE
+c
+c===================================================================
+c Auteur : E. Cosme 
+c Calcul de la vitesse de friction (ustar) et de la longueur de 
+c Monin-Obukhov (obklen), necessaires pour calculer les flux de DMS
+c par la methode de Nightingale.
+c Cette subroutine est plus que fortement inspiree de la subroutine
+c 'nonlocal' dans clmain.F .
+c reference :  Holtslag, A.A.M., and B.A. Boville, 1993:
+c Local versus nonlocal boundary-layer diffusion in a global climate
+c model. J. of Climate, vol. 6, 1825-1842. (a confirmer)
+c 31 08 01
+c===================================================================
+c
+#include "dimensions.h"
+#include "YOMCST.h"
+#include "YOETHF.h"
+#include "FCTTRE.h"
+c
+c Arguments :
+      REAL u(klon,klev)          ! vent zonal
+      REAL v(klon,klev)          ! vent meridien
+      REAL paprs(klon,klev+1)    ! niveaux de pression aux intercouches (Pa)
+      REAL pplay(klon,klev)      ! niveaux de pression aux milieux... (Pa)
+      REAL cdragh(klon)          ! coefficient de trainee pour la chaleur
+      REAL cdragm(klon)          ! coefficient de trainee pour le vent
+      REAL t(klon,klev)          ! temperature
+      REAL q(klon,klev)          ! humidite kg/kg
+      REAL tsol(klon)            ! temperature du sol
+      REAL ustar(klon)           ! vitesse de friction
+      REAL obklen(klon)          ! longueur de Monin-Obukhov
+c
+c Locales :
+      REAL vk
+      PARAMETER (vk=0.35)
+      REAL beta  ! coefficient d'evaporation reelle (/evapotranspiration)
+                 ! entre 0 et 1, mais 1 au-dessus de la mer
+      PARAMETER (beta=1.)
+      INTEGER i,k
+      REAL zxt, zxu, zxv, zxq, zxqs, zxmod, taux, tauy
+      REAL zcor, zdelta, zcvm5
+      REAL z(klon,klev)
+      REAL zx_alf1, zx_alf2 ! parametres pour extrapolation
+      REAL khfs(klon)       ! surface kinematic heat flux [mK/s]
+      REAL kqfs(klon)       ! sfc kinematic constituent flux [m/s]
+      REAL heatv(klon)      ! surface virtual heat flux
+
+      
+c
+c======================================================================
+c
+c Calculer les hauteurs de chaque couche
+c
+! JE20150707      r2es=611.14 *18.0153/28.9644
+      DO i = 1, klon
+         z(i,1) = RD * t(i,1) / (0.5*(paprs(i,1)+pplay(i,1)))
+     .               * (paprs(i,1)-pplay(i,1)) / RG
+      ENDDO
+      DO k = 2, klev
+      DO i = 1, klon
+         z(i,k) = z(i,k-1)
+     .              + RD * 0.5*(t(i,k-1)+t(i,k)) / paprs(i,k)
+     .                   * (pplay(i,k-1)-pplay(i,k)) / RG
+      ENDDO
+      ENDDO
+
+      DO i = 1, klon
+c
+        zdelta=MAX(0.,SIGN(1.,RTT-tsol(i)))
+        zcvm5 = R5LES*RLVTT*(1.-zdelta) + R5IES*RLSTT*zdelta
+        zcvm5 = zcvm5 / RCPD / (1.0+RVTMP2*q(i,1))
+        zxqs= r2es * FOEEW(tsol(i),zdelta)/paprs(i,1)
+        zxqs=MIN(0.5,zxqs)
+        zcor=1./(1.-retv*zxqs)
+        zxqs=zxqs*zcor
+c
+        zx_alf1 = 1.0
+        zx_alf2 = 1.0 - zx_alf1
+        zxt = (t(i,1)+z(i,1)*RG/RCPD/(1.+RVTMP2*q(i,1)))
+     .        *(1.+RETV*q(i,1))*zx_alf1
+     .      + (t(i,2)+z(i,2)*RG/RCPD/(1.+RVTMP2*q(i,2)))
+     .        *(1.+RETV*q(i,2))*zx_alf2
+        zxu = u(i,1)*zx_alf1+u(i,2)*zx_alf2
+        zxv = v(i,1)*zx_alf1+v(i,2)*zx_alf2
+        zxq = q(i,1)*zx_alf1+q(i,2)*zx_alf2
+        zxmod = 1.0+SQRT(zxu**2+zxv**2)
+        khfs(i) = (tsol(i)*(1.+RETV*q(i,1))-zxt) *zxmod*cdragh(i)
+        kqfs(i) = (zxqs-zxq) *zxmod*cdragh(i) * beta
+        heatv(i) = khfs(i) + 0.61*zxt*kqfs(i)
+        taux = zxu *zxmod*cdragm(i)
+        tauy = zxv *zxmod*cdragm(i)
+        ustar(i) = SQRT(taux**2+tauy**2)
+        ustar(i) = MAX(SQRT(ustar(i)),0.01)
+c
+      ENDDO
+c
+      DO i = 1, klon
+         obklen(i) = -t(i,1)*ustar(i)**3/(RG*vk*heatv(i))
+      ENDDO
+c
+      END SUBROUTINE
Index: LMDZ5/branches/testing/libf/phylmd/Dust/blcloud_scav.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/blcloud_scav.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/blcloud_scav.F	(revision 2641)
@@ -0,0 +1,125 @@
+c Subroutine that calculates the effect of precipitation in scavenging
+c BELOW the cloud, for large scale as well as convective precipitation
+      SUBROUTINE blcloud_scav(lminmax,qmin,qmax,pdtphys,prfl,psfl,
+     .                        pmflxr,pmflxs,zdz,alpha_r,alpha_s,masse,
+     .                                  his_dhbclsc,his_dhbccon,tr_seri)
+
+      USE dimphy
+      USE indice_sol_mod
+      USE infotrac
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "chem.h"
+#include "YOMCST.h"
+#include "paramet.h"
+
+c============================= INPUT ===================================
+      REAL qmin,qmax
+      REAL pdtphys  ! pas d'integration pour la physique (seconde)
+!      REAL prfl(klon,klev),   psfl(klon,klev)     !--large-scale
+!      REAL pmflxr(klon,klev), pmflxs(klon,klev)   !--convection
+      REAL alpha_r(nbtr)!--coefficient d'impaction pour la pluie
+      REAL alpha_s(nbtr)!--coefficient d'impaction pour la neige      
+      REAL masse(nbtr)
+      LOGICAL lminmax
+      REAL zdz(klon,klev)
+      REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--large-scale  ! Titane
+      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--convection   ! Titane
+c============================= OUTPUT ==================================
+      REAL tr_seri(klon,klev,nbtr) ! traceur
+      REAL aux_var1(klon,klev) ! traceur
+      REAL aux_var2(klon,klev) ! traceur
+      REAL his_dhbclsc(klon,nbtr), his_dhbccon(klon,nbtr)
+c========================= LOCAL VARIABLES =============================      
+      INTEGER it, k, i, j
+      REAL d_tr(klon,klev,nbtr)
+
+      EXTERNAL minmaxqfi, bcscav_spl
+      
+      DO it=1, nbtr
+c
+      DO j=1,klev
+      DO i=1,klon
+        aux_var1(i,j)=tr_seri(i,j,it)
+        aux_var2(i,j)=d_tr(i,j,it)
+      ENDDO
+      ENDDO
+c
+cnhl      CALL bcscav_spl(pdtphys,prfl,psfl,alpha_r(it),alpha_s(it),
+cnhl     .                tr_seri(1,1,it),d_tr(1,1,it))
+      CALL bcscav_spl(pdtphys,prfl,psfl,alpha_r(it),alpha_s(it),
+     .                aux_var1,aux_var2)
+c
+      DO j=1,klev
+      DO i=1,klon
+        tr_seri(i,j,it)=aux_var1(i,j)
+        d_tr(i,j,it)=aux_var2(i,j)
+      ENDDO
+      ENDDO
+      DO k = 1, klev
+      DO i = 1, klon
+         tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr(i,k,it)
+         his_dhbclsc(i,it)=his_dhbclsc(i,it)-d_tr(i,k,it)/RNAVO*
+     .                masse(it)*1.e3*1.e6*zdz(i,k)/pdtphys  !--mgS/m2/s
+              
+      ENDDO
+      ENDDO
+c
+      DO i=1,klon
+      DO j=1,klev
+        aux_var1(i,j)=tr_seri(i,j,it)
+        aux_var2(i,j)=d_tr(i,j,it)
+      ENDDO
+      ENDDO
+c
+      IF (lminmax) THEN
+        CALL minmaxqfi(aux_var1,qmin,qmax,'depot humide bc lsc')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'depot humide bc lsc')
+      ENDIF
+c
+c-scheme for convective scavenging
+c
+cnhl      CALL bcscav_spl(pdtphys,pmflxr,pmflxs,alpha_r(it),alpha_s(it),
+cnhl     .                tr_seri(1,1,it),d_tr(1,1,it))
+
+
+      CALL bcscav_spl(pdtphys,pmflxr,pmflxs,alpha_r(it),alpha_s(it),
+     .                aux_var1,aux_var2)
+
+
+c
+      DO i=1,klon
+      DO j=1,klev
+        tr_seri(i,j,it)=aux_var1(i,j)
+        d_tr(i,j,it)=aux_var2(i,j)
+      ENDDO
+      ENDDO
+c
+      DO k = 1, klev
+      DO i = 1, klon
+         tr_seri(i,k,it) = tr_seri(i,k,it) + d_tr(i,k,it)
+         his_dhbccon(i,it)=his_dhbccon(i,it)-d_tr(i,k,it)/RNAVO*
+     .                masse(it)*1.e3*1.e6*zdz(i,k)/pdtphys    !--mgS/m2/s
+      ENDDO
+      ENDDO
+c
+      IF (lminmax) THEN
+        DO j=1,klev
+        DO i=1,klon
+          aux_var1(i,j)=tr_seri(i,j,it)
+        ENDDO
+        ENDDO
+        CALL minmaxqfi(aux_var1,qmin,qmax,'depot humide bc con')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'depot humide bc con')
+        DO j=1,klev
+        DO i=1,klon
+          tr_seri(i,j,it)=aux_var1(i,j)
+        ENDDO
+        ENDDO
+      ENDIF
+c
+c
+      ENDDO !--boucle sur it
+c
+      END
